/**
 * 
 */
package it.unicam.cs.tesei.trees;

/**
 * @author luca
 *
 */
public class BinTreeTest {

    /**
     * @param args
     */
    public static void main(String[] args) {
        BinTree<Integer> b1 = new BinTree<>(new Integer(1));
        BinTree<Integer> b2 = new BinTree<>(new Integer(2));
        BinTree<Integer> b3 = new BinTree<>(new Integer(3));
        BinTree<Integer> b4 = new BinTree<>(new Integer(4));
        BinTree<Integer> b5 = new BinTree<>(new Integer(5));
        BinTree<Integer> b6 = new BinTree<>(new Integer(6));
        BinTree<Integer> b7 = new BinTree<>(new Integer(7));
        BinTree<Integer> b8 = new BinTree<>(new Integer(8));
        BinTree<Integer> b9 = new BinTree<>(new Integer(9));
        BinTree<Integer> b10 = new BinTree<>(new Integer(10));
        BinTree<Integer> b11 = new BinTree<>(new Integer(11));
        BinTree<Integer> b12 = new BinTree<>(new Integer(12));
        
        BinTree<Integer> c1 = new BinTree<>(b1, new Integer(13));
        BinTree<Integer> c2 = new BinTree<>(b12, new Integer(14));
        BinTree<Integer> c3 = new BinTree<>(b5, new Integer(15));
        BinTree<Integer> c4 = new BinTree<>(b7, new Integer(16));
        BinTree<Integer> c5 = new BinTree<>(b2, new Integer(17));

        BinTree<Integer> c6 = new BinTree<>(new Integer(18), b2);
        BinTree<Integer> c7 = new BinTree<>(new Integer(19), b4);
        BinTree<Integer> c8 = new BinTree<>(new Integer(20), b3);
        BinTree<Integer> c9 = new BinTree<>(new Integer(21), b6);
        BinTree<Integer> c10 = new BinTree<>(new Integer(22), b8);
        
        BinTree<Integer> d1 = new BinTree<>(c8, new Integer(23),b12);
        BinTree<Integer> d2 = new BinTree<>(c1, new Integer(24),c2);
        BinTree<Integer> d3 = new BinTree<>(b10, new Integer(25),c4);
        BinTree<Integer> d4 = new BinTree<>(c7, new Integer(26),b9);
        BinTree<Integer> d5 = new BinTree<>(c10, new Integer(27),d1);
        BinTree<Integer> d6 = new BinTree<>(c5, new Integer(28),b8);
        BinTree<Integer> d7 = new BinTree<>(d6, new Integer(29),d5);
        BinTree<Integer> d8 = new BinTree<>(d7, new Integer(30),b4);
        BinTree<Integer> d9 = new BinTree<>(c9, new Integer(31));
        
        BinTree<Integer> e1 = new BinTree<>(d7, new Integer(32), d3);
        BinTree<Integer> e2 = new BinTree<>(e1, new Integer(32), d6);
        BinTree<Integer> e3 = new BinTree<>(d9, new Integer(32), e2);
        
        System.out.println("e1 - Parentesizzazione");
        System.out.println(e1.getParentesizzazione());
        
        System.out.println("e1 - Parentesizzazione con elementi");
        System.out.println(e1.getParentesizzazioneConElementi());
        
        System.out.println("e1 - visita anticipata");
        System.out.println(e1.visitaAnticipata());
        
        System.out.println("e1 - visita posticipata");
        System.out.println(e1.visitaPosticipata());
        
        System.out.print("e1 - altezza: ");
        System.out.println(e1.getHeight());
        
        System.out.println("e2 - Parentesizzazione");
        System.out.println(e2.getParentesizzazione());
        
        System.out.println("e2 - Parentesizzazione con elementi");
        System.out.println(e2.getParentesizzazioneConElementi());
        
        System.out.println("e2 - visita anticipata");
        System.out.println(e2.visitaAnticipata());
        
        System.out.println("e2 - visita posticipata");
        System.out.println(e2.visitaPosticipata());
        
        System.out.print("e2 - altezza: ");
        System.out.println(e2.getHeight());
        
        System.out.println("e3 - Parentesizzazione");
        System.out.println(e3.getParentesizzazione());
        
        System.out.println("e3 - Parentesizzazione con elementi");
        System.out.println(e3.getParentesizzazioneConElementi());
        
        System.out.println("e3 - visita anticipata");
        System.out.println(e3.visitaAnticipata());
        
        System.out.println("e3 - visita posticipata");
        System.out.println(e3.visitaPosticipata());
        
        System.out.print("e3 - altezza: ");
        System.out.println(e3.getHeight());
        
        
    }
    
    

}
